SystemOrganization addCategory: #'EjerciciosPoo-TusLibros'!

TestCase subclass: #TusLibrosTest
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'EjerciciosPoo-TusLibros'!

!TusLibrosTest methodsFor: 'as yet unclassified' stamp: 'RavasiAronson 6/26/2012 00:44'!
createCartAndGetId: aMarketplace
	^ (((aMarketplace createCartForUser: 'Alex' withPassword: 'pass') subStrings: '|') at: 2) asNumber! !

!TusLibrosTest methodsFor: 'as yet unclassified' stamp: 'RavasiAronson 6/26/2012 01:16'!
createMPInterfaceStubWithErrorShouldNotHaveCalledMP
	
	^InterfaceStub createMPInterfaceStubWithExpectedReturn: [Error signal: self errorNotCall]! !

!TusLibrosTest methodsFor: 'as yet unclassified' stamp: 'RavasiAronson 6/17/2012 21:48'!
creditCard
	^ CreditCard ownedBy: 'Juan' identifiedBy: 123456 expiresOn: (MonthOfYear januaryOf: Date current year + 1)! !

!TusLibrosTest methodsFor: 'tests' stamp: 'RavasiAronson 6/17/2012 23:06'!
emptyCart
	
	 ^Cart withPairedCollection:  #('book1' 10  'book2' 5 'book3' 1)! !

!TusLibrosTest methodsFor: 'as yet unclassified' stamp: 'RavasiAronson 6/25/2012 19:31'!
errorNotCall
	
	 ^'The cashier shouldnt have called the merchant processor'! !

!TusLibrosTest methodsFor: 'as yet unclassified' stamp: 'RavasiAronson 6/17/2012 22:26'!
expiredDate
	^MonthOfYear januaryOf: Date current year - 1! !

!TusLibrosTest methodsFor: 'tests' stamp: 'RavasiAronson 6/17/2012 21:57'!
fullCart
	^ self emptyCart
		add: 'book1' withQuantity: 2;
		add: 'book2' withQuantity: 1! !

!TusLibrosTest methodsFor: 'as yet unclassified' stamp: 'RavasiAronson 6/25/2012 20:59'!
marketplace
	
	 ^MarketplaceInterface withPairedCollectionOfBooks:  #('book1' 10  'book2' 5 'book3' 1 )withPairedCollectionOfUsers: #('Nico' 'abc' 'Alex' 'pass').! !

!TusLibrosTest methodsFor: 'as yet unclassified' stamp: 'RavasiAronson 6/25/2012 21:28'!
marketplaceWithCreatedCart
	| marketplace |
	marketplace := self marketplace.
	marketplace createCartForUser: 'Alex' withPassword: 'pass'.
	^ marketplace! !

!TusLibrosTest methodsFor: 'as yet unclassified' stamp: 'RavasiAronson 6/26/2012 01:14'!
marketplaceWithTimerStub: aStub
	
	 ^MarketplaceInterface withPairedCollectionOfBooks:  #('book1' 10  'book2' 5 'book3' 1 )withPairedCollectionOfUsers: #('Nico' 'abc' 'Alex' 'pass') withTimer: aStub! !

!TusLibrosTest methodsFor: 'tests' stamp: 'RavasiAronson 6/17/2012 21:50'!
test01CartsAreCreatedEmpty
	self assert: (self emptyCart isEmpty)! !

!TusLibrosTest methodsFor: 'tests' stamp: 'RavasiAronson 6/17/2012 23:55'!
test02CantAddBookNotInCatalogToCart
	| cart |
	cart := self emptyCart.
	self should: [ cart add: 'notBook' withQuantity: 1 ] raise: Error
		withExceptionDo: [ :anError | anError messageText = 'Book not in catalog' ]..
	self assert: cart isEmpty.! !

!TusLibrosTest methodsFor: 'tests' stamp: 'RavasiAronson 6/17/2012 23:56'!
test03CantAddZeroOrNegativeNumberOfBooks
	| cart |
	cart := self emptyCart.
	self should: [ cart add: 'book1' withQuantity: 0 ] raise: Error
		withExceptionDo: [ :anError | anError messageText = 'Not a valid quantity' ].
	self assert: cart listContents isEmpty.
	self should: [ cart add: 'book1' withQuantity: -1 ] raise: Error
		withExceptionDo: [ :anError | anError messageText = 'Not a valid quantity' ].
	self assert: cart listContents isEmpty! !

!TusLibrosTest methodsFor: 'tests' stamp: 'RavasiAronson 6/17/2012 21:50'!
test04ACanAddBookInCatalogue
	| cart list |
	cart := self emptyCart.
	cart add: 'book1' withQuantity: 1.
	list := cart listContents.
	self assert: (list occurrencesOf: 'book1') = 1! !

!TusLibrosTest methodsFor: 'tests' stamp: 'RavasiAronson 6/17/2012 21:50'!
test04BCanAddMultipleBooksMultipleTimes
	| cart list |
	cart := self emptyCart.
	cart add: 'book1' withQuantity: 1.
	cart add: 'book1' withQuantity: 3.
	cart add: 'book2' withQuantity: 2.
	list := cart listContents.
	self assert: (list occurrencesOf: 'book1') = 4.
	self assert: (list occurrencesOf: 'book2') = 2! !

!TusLibrosTest methodsFor: 'tests' stamp: 'RavasiAronson 6/17/2012 23:20'!
test05AEmptyCartCostsZero
	| cart list |
	cart := self emptyCart.
	self assert: cart calculateTotalPrice = 0! !

!TusLibrosTest methodsFor: 'tests' stamp: 'RavasiAronson 6/18/2012 19:26'!
test05BCartCostIsCorrect
	| cart list |
	cart := self emptyCart.
	cart add: 'book1' withQuantity: 4.
	cart add: 'book2' withQuantity: 2.
	
	self assert: cart calculateTotalPrice = 50! !

!TusLibrosTest methodsFor: 'tests' stamp: 'RavasiAronson 6/25/2012 19:32'!
test06CantCheckoutEmptyCart
	| cashier interface |
	interface := self createMPInterfaceStubWithErrorShouldNotHaveCalledMP.
	cashier := Cashier new.
	cashier useInterface: interface.
	self
		should: [ 
			cashier checkout: self emptyCart withCreditCard: self creditCard 
				]
		raise: Error
		withExceptionDo: [ :anError | self assert: anError messageText = 'Cart should not be empty' ]! !

!TusLibrosTest methodsFor: 'tests' stamp: 'RavasiAronson 6/25/2012 19:33'!
test07CantCheckoutWithExpiredCreditCard
	| cashier interface |
	interface := self createMPInterfaceStubWithErrorShouldNotHaveCalledMP.
	cashier := Cashier new.
	cashier useInterface: interface.
	self
		should: [ 
			cashier
				checkout: self fullCart
				withCreditCard: (CreditCard ownedBy: 'Juan' identifiedBy: 1222 expiresOn: self expiredDate) ]
		raise: Error
		withExceptionDo: [ :anError | self assert:  anError messageText = 'Credit card is expired' ].! !

!TusLibrosTest methodsFor: 'tests' stamp: 'RavasiAronson 6/25/2012 19:33'!
test08CantCheckoutWithNameTooLong
	| cashier interface |
	interface := self createMPInterfaceStubWithErrorShouldNotHaveCalledMP.
	cashier := Cashier new.
	cashier useInterface: interface.
	self
		should: [ 
			cashier
				checkout: self fullCart
				withCreditCard:
					(CreditCard ownedBy: 'JuanJuanJuanJuanJuanJuanJuanJuan' identifiedBy: 1222 expiresOn: self validDate) ]
		raise: Error
		withExceptionDo: [ :anError | self assert: anError messageText = 'Owner name is too long' ].! !

!TusLibrosTest methodsFor: 'tests' stamp: 'RavasiAronson 6/26/2012 01:16'!
test09CantCheckoutNoCreditInCard
	| cashier interface |
	interface := InterfaceStub createMPInterfaceStubWithExpectedReturn: [ MPError signal: 'No credit in card' ].
	cashier := Cashier new.
	cashier useInterface: interface.
	self
		should: [ 
			cashier
				checkout: self fullCart
				withCreditCard: (CreditCard ownedBy: 'Juan' identifiedBy: 1222 expiresOn: self validDate) ]
		raise: Error
		withExceptionDo: [ :anError | self assert: anError messageText = 'Error processing card, not enough credit to process transaction' ]! !

!TusLibrosTest methodsFor: 'tests' stamp: 'RavasiAronson 6/26/2012 01:16'!
test10CantCheckoutCardStolen
	| cashier interface |
	interface := InterfaceStub createMPInterfaceStubWithExpectedReturn: [ MPError signal: 'Card stolen'].
	cashier := Cashier new.
	cashier useInterface: interface.
	self
		should: [ 
			cashier
				checkout: self fullCart
				withCreditCard: (CreditCard ownedBy: 'Juan' identifiedBy: 1222 expiresOn: self validDate) ]
		raise: Error
		withExceptionDo: [ :anError | self assert: anError messageText = 'Error processing card,, card is flagged as stolen' ]! !

!TusLibrosTest methodsFor: 'tests' stamp: 'RavasiAronson 6/27/2012 00:25'!
test11CanCheckoutWithValidCCAndCart
	| cashier interface |
	interface := InterfaceStub createMPInterfaceStubWithExpectedReturn: [ true ].
	cashier := Cashier new.
	cashier useInterface: interface.
	self assert: (cashier
		checkout: self fullCart
		withCreditCard: (CreditCard ownedBy: 'Juan' identifiedBy: 1222 expiresOn: self validDate)) = 25! !

!TusLibrosTest methodsFor: 'tests' stamp: 'RavasiAronson 6/25/2012 21:39'!
test12MarketplaceCanCreateCartWithValidUserAndPassword
	| marketplace  |

	marketplace := self marketplace.
	self assert: (marketplace createCartForUser: 'Alex' withPassword: 'pass') = '0|1'.
	
	
! !

!TusLibrosTest methodsFor: 'tests' stamp: 'RavasiAronson 6/25/2012 21:38'!
test13MarketplaceCannotCreateCartWithInvalidUser
	| marketplace  |

	marketplace := self marketplace.
	self assert: (marketplace createCartForUser: 'Ale' withPassword: '123') = '1|User not found'
	
	
! !

!TusLibrosTest methodsFor: 'tests' stamp: 'RavasiAronson 6/25/2012 21:38'!
test14MarketplaceCannotCreateCartWithValidUserInvalidPassword
	| marketplace  |

	marketplace := self marketplace.
	self assert: (marketplace createCartForUser: 'Alex' withPassword: '12') = '1|Incorrect password'.
	
	
! !

!TusLibrosTest methodsFor: 'tests' stamp: 'RavasiAronson 6/25/2012 21:38'!
test15MarketplaceCannotAddToNonexistingCart
	| marketplace  |

	marketplace := self marketplaceWithCreatedCart.
	self assert: (marketplace addToCart: 2 book: 'book1' times: 2) = '1|Cart id not found'.
	
	
! !

!TusLibrosTest methodsFor: 'tests' stamp: 'RavasiAronson 6/26/2012 00:48'!
test16MarketplaceCanAddValidBookToValidCart
	| marketplace string |
	marketplace := self marketplaceWithCreatedCart.
	string := marketplace addToCart: 1 book: 'book1' times: 2.
	self assert: (string includesSubString: '0|') & (string size > 2)! !

!TusLibrosTest methodsFor: 'tests' stamp: 'RavasiAronson 6/25/2012 21:40'!
test17MarketplaceCannotListNonexistingCart
	| marketplace |
	marketplace := self marketplaceWithCreatedCart.
	self assert: (marketplace listCart: 2) = '1|Cart id not found'! !

!TusLibrosTest methodsFor: 'tests' stamp: 'RavasiAronson 6/26/2012 00:45'!
test18MarketplaceCanListValidEmptyCart
	| marketplace id|
	marketplace := self marketplace.
	id := self createCartAndGetId: marketplace.
	self assert: ((marketplace listCart: id) =  '0|')! !

!TusLibrosTest methodsFor: 'tests' stamp: 'RavasiAronson 6/26/2012 00:45'!
test19MarketplaceCanListValidFullCart
	| marketplace id|
	marketplace := self marketplace.
	id := self createCartAndGetId: marketplace.
	marketplace addToCart: id book: 'book1' times: 3.
	marketplace addToCart: id book: 'book2' times: 4.
	self assert: ((marketplace listCart: id) =  '0|book1|3|book2|4')! !

!TusLibrosTest methodsFor: 'tests' stamp: 'RavasiAronson 6/26/2012 01:21'!
test20MarketplaceCannotAddToCartWithExpiredSession
	| marketplace id stub |
	stub := TimerStub  new.
	marketplace := self marketplaceWithTimerStub: stub.
	id := self createCartAndGetId: marketplace.
	stub expire.
	self assert: (marketplace addToCart: id book: 'book1' times: 3) = '1|Session is expired'! !

!TusLibrosTest methodsFor: 'tests' stamp: 'RavasiAronson 6/26/2012 01:20'!
test21MarketplaceCannotListCartWithExpiredSession
	| marketplace id  stub|
	stub := TimerStub new.
	marketplace := self marketplaceWithTimerStub: stub.
	id := self createCartAndGetId: marketplace.
	marketplace addToCart: id book: 'book1' times: 3.
	stub expire.
	self assert: (marketplace listCart: id) = '1|Session is expired'! !

!TusLibrosTest methodsFor: 'tests' stamp: 'RavasiAronson 6/27/2012 00:20'!
test22MarketplaceCannotAddToCartUnlistedBook
	| marketplace id|
	marketplace := self marketplace.
	id := self createCartAndGetId: marketplace.
	self assert: (marketplace addToCart: id book: 'notbook' times: 2) = '1|Book not in catalog'.
	self assert: (marketplace listCart: id) =  '0|'.! !

!TusLibrosTest methodsFor: 'tests' stamp: 'RavasiAronson 6/27/2012 00:20'!
test23MarketplaceCannotAddToCartUnlistedBook
	| marketplace id|
	marketplace := self marketplace.
	id := self createCartAndGetId: marketplace.
	self assert: (marketplace addToCart: id book: 'book1' times: 0) = '1|Not a valid quantity'.
	self assert: (marketplace listCart: id) =  '0|'.
	self assert: (marketplace addToCart: id book: 'book1' times: -1) = '1|Not a valid quantity'.
	self assert: (marketplace listCart: id) =  '0|'.! !

!TusLibrosTest methodsFor: 'as yet unclassified' stamp: 'RavasiAronson 6/17/2012 23:34'!
validDate
	^MonthOfYear januaryOf: Date current year + 1! !

Error subclass: #MPError
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'EjerciciosPoo-TusLibros'!

Object subclass: #Cart
	instanceVariableNames: 'contents catalog'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'EjerciciosPoo-TusLibros'!

!Cart class methodsFor: 'as yet unclassified' stamp: 'RavasiAronson 6/17/2012 23:04'!
withCatalog: aDictionary 
	^Cart new initializeCatalogOn: aDictionary! !

!Cart class methodsFor: 'as yet unclassified' stamp: 'RavasiAronson 6/17/2012 23:05'!
withPairedCollection: aCollection
	^Cart withCatalog:  (Dictionary newFromPairs: aCollection)! !

!Cart methodsFor: 'as yet unclassified' stamp: 'RavasiAronson 6/17/2012 23:55'!
add: anISBN withQuantity: aNumber
	
	aNumber > 0 ifFalse: [Error signal: 'Not a valid quantity'].
	(self isAListedISBN: anISBN) ifFalse: [Error signal: 'Book not in catalog'].
	contents add: anISBN withOccurrences: aNumber.! !

!Cart methodsFor: 'as yet unclassified' stamp: 'RavasiAronson 6/17/2012 23:21'!
calculateTotalPrice
	| accumulated |
	accumulated := 0.
	contents do: [ :each | accumulated := accumulated + (catalog at: each) ].
	^accumulated ! !

!Cart methodsFor: 'as yet unclassified' stamp: 'RavasiAronson 6/13/2012 21:29'!
initializeCatalogOn: aCollection 
	catalog := aCollection.
	contents := Bag new.! !

!Cart methodsFor: 'as yet unclassified' stamp: 'RavasiAronson 6/17/2012 23:08'!
isAListedISBN: anISBN  
	
	^catalog includesKey: anISBN.! !

!Cart methodsFor: 'as yet unclassified' stamp: 'RavasiAronson 6/13/2012 21:32'!
isEmpty
	^contents isEmpty! !

!Cart methodsFor: 'as yet unclassified' stamp: 'RavasiAronson 6/12/2012 19:11'!
listContents
	^ contents.! !

Object subclass: #Cashier
	instanceVariableNames: 'interface'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'EjerciciosPoo-TusLibros'!

!Cashier methodsFor: 'as yet unclassified' stamp: 'RavasiAronson 6/27/2012 00:26'!
callMPWithCC: aCreditCard forTotal: aNumber 
	
	interface callWithCC: aCreditCard forTotal: aNumber! !

!Cashier methodsFor: 'as yet unclassified' stamp: 'RavasiAronson 6/17/2012 23:27'!
checkCartIsNotEmpty: aCart
	aCart isEmpty
		ifTrue: [ Error signal: 'Cart should not be empty' ]! !

!Cashier methodsFor: 'as yet unclassified' stamp: 'RavasiAronson 6/27/2012 00:24'!
checkout: aCart withCreditCard: aCreditCard
	| total |
	self checkCartIsNotEmpty: aCart.
	self validateCreditCard: aCreditCard.
	total := aCart calculateTotalPrice.
	[ self callMPWithCC: aCreditCard forTotal: total ]
		on: MPError
		do: [ :anError | 
			anError messageText = 'No credit in card'
				ifTrue: [ Error signal: 'Error processing card, not enough credit to process transaction' ].
			anError messageText = 'Card stolen'
				ifTrue: [ Error signal: 'Error processing card,, card is flagged as stolen' ] ].
	^ total! !

!Cashier methodsFor: 'as yet unclassified' stamp: 'RavasiAronson 6/25/2012 19:21'!
initialize
	interface := MPInterface new! !

!Cashier methodsFor: 'as yet unclassified' stamp: 'RavasiAronson 6/17/2012 23:27'!
today
	"Este mtodo lo pusimos en cashier porque tuvimos problemas al agregarlo al paquete credit card, no lo suba al comitear"

	| currentDate |
	currentDate := Date current.
	^ MonthOfYear onMonthNumber: currentDate month index of: currentDate year! !

!Cashier methodsFor: 'as yet unclassified' stamp: 'RavasiAronson 6/25/2012 19:52'!
useInterface: anMPInterface
	interface := anMPInterface! !

!Cashier methodsFor: 'as yet unclassified' stamp: 'RavasiAronson 6/18/2012 19:22'!
validateCreditCard: aCreditCard
	(aCreditCard isExpiredOn: self today)
		ifTrue: [ Error signal: 'Credit card is expired' ].
	aCreditCard ownerName size > 30
		ifTrue: [ Error signal: 'Owner name is too long' ]! !

Object subclass: #InterfaceStub
	instanceVariableNames: 'stubBlock'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'EjerciciosPoo-TusLibros'!

!InterfaceStub class methodsFor: 'as yet unclassified' stamp: 'RavasiAronson 6/26/2012 01:16'!
createMPInterfaceStubWithExpectedReturn: aBlock
	^ InterfaceStub new initializeStubBlockOn: aBlock! !

!InterfaceStub methodsFor: 'as yet unclassified' stamp: 'RavasiAronson 6/27/2012 00:26'!
callWithCC: aCreditCard forTotal: aSmallInteger
	stubBlock value.! !

!InterfaceStub methodsFor: 'as yet unclassified' stamp: 'RavasiAronson 6/25/2012 19:17'!
initializeStubBlockOn: aBlock
	
	stubBlock := aBlock.
! !

Object subclass: #MPInterface
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'EjerciciosPoo-TusLibros'!

!MPInterface methodsFor: 'as yet unclassified' stamp: 'RavasiAronson 6/27/2012 00:26'!
callWithCC: aCreditCard forTotal: aSmallInteger
	self shouldBeImplemented.! !

Object subclass: #MarketplaceInterface
	instanceVariableNames: 'carts catalog lastModified nextId users timer'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'EjerciciosPoo-TusLibros'!

!MarketplaceInterface class methodsFor: 'as yet unclassified' stamp: 'RavasiAronson 6/26/2012 00:59'!
withCatalog: aCatalog withUsers: users
	^((MarketplaceInterface new initializeCatalogOn: aCatalog) initializeUsersOn: users) initializeTimerOn: Timer new! !

!MarketplaceInterface class methodsFor: 'as yet unclassified' stamp: 'RavasiAronson 6/25/2012 20:46'!
withPairedCollectionOfBooks: aCollection withPairedCollectionOfUsers: users
	^ MarketplaceInterface withCatalog: (Dictionary newFromPairs: aCollection) withUsers: (Dictionary newFromPairs: users)! !

!MarketplaceInterface class methodsFor: 'as yet unclassified' stamp: 'RavasiAronson 6/26/2012 00:59'!
withPairedCollectionOfBooks: aCollection withPairedCollectionOfUsers: users withTimer: aTimer
	^ (MarketplaceInterface withCatalog: (Dictionary newFromPairs: aCollection) withUsers: (Dictionary newFromPairs: users))
		initializeTimerOn: aTimer! !

!MarketplaceInterface methodsFor: 'as yet unclassified' stamp: 'RavasiAronson 6/27/2012 16:11'!
addToCart: aCartId book: aBook times: aNumber
	| cart |
	cart := carts at: aCartId ifAbsent: [ ^ '1|Cart id not found' ].
	(self isNotExpired: aCartId)
		ifFalse: [ ^ '1|Session is expired' ].
	self updateTimeFor: aCartId.
	[ cart add: aBook withQuantity: aNumber ]
		on: Error
		do: [ :anError | ^ '1|' , anError messageText ].
	^ '0|OK'! !

!MarketplaceInterface methodsFor: 'as yet unclassified' stamp: 'RavasiAronson 6/25/2012 21:39'!
createCartForUser: aUser withPassword: aPassword
	| cart id obtainedPassword |
	obtainedPassword := users at: aUser ifAbsent: [ ^ '1|User not found' ].
	obtainedPassword = aPassword
		ifFalse: [ ^ '1|Incorrect password' ].
	cart := Cart withCatalog: catalog.
	id := nextId.
	carts at: id put: cart.
	self updateTimeFor: id.
	self increaseNextId.
	^ '0|' , id name ! !

!MarketplaceInterface methodsFor: 'as yet unclassified' stamp: 'RavasiAronson 6/25/2012 20:42'!
increaseNextId 

	nextId := nextId + 1! !

!MarketplaceInterface methodsFor: 'as yet unclassified' stamp: 'RavasiAronson 6/25/2012 20:35'!
initializeCatalogOn: aCollection 
	catalog := aCollection.
	carts := Dictionary  new.
	lastModified := Dictionary new.
	nextId := 1.! !

!MarketplaceInterface methodsFor: 'as yet unclassified' stamp: 'RavasiAronson 6/26/2012 00:57'!
initializeTimerOn: aTimer 
	timer := aTimer ! !

!MarketplaceInterface methodsFor: 'as yet unclassified' stamp: 'RavasiAronson 6/25/2012 20:54'!
initializeUsersOn: aDictionary 
	users := aDictionary ! !

!MarketplaceInterface methodsFor: 'as yet unclassified' stamp: 'RavasiAronson 6/26/2012 01:07'!
isNotExpired: aCartId
	^ (lastModified at: aCartId) > timer thirtyMinsAgo! !

!MarketplaceInterface methodsFor: 'as yet unclassified' stamp: 'RavasiAronson 6/27/2012 16:11'!
listCart: aCartId
	| cart |
	cart := carts at: aCartId ifAbsent: [ ^ '1|Cart id not found' ].
	(self isNotExpired: aCartId)
		ifFalse: [ ^ '1|Session is expired' ].
	self updateTimeFor: aCartId.
	^ '0|' , (self listContents: cart listContents)! !

!MarketplaceInterface methodsFor: 'as yet unclassified' stamp: 'RavasiAronson 6/26/2012 00:38'!
listContents: aCollection
	| string |
	string := ''.
	aCollection asSet do: [ :each | string := (string , each , '|' , (aCollection occurrencesOf: each) name , '|') ].
	string isEmpty
		ifFalse: [ string := string truncateTo: string size - 1 ].
	^ string! !

!MarketplaceInterface methodsFor: 'as yet unclassified' stamp: 'RavasiAronson 6/26/2012 01:04'!
updateTimeFor: anId
	lastModified at: anId put: timer currentTime! !

Object subclass: #Timer
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'EjerciciosPoo-TusLibros'!

!Timer methodsFor: 'as yet unclassified' stamp: 'RavasiAronson 6/26/2012 00:56'!
currentTime
	^TimeStamp current
	! !

!Timer methodsFor: 'as yet unclassified' stamp: 'RavasiAronson 6/26/2012 00:56'!
thirtyMinsAgo
	^ TimeStamp current - (Duration minutes: 30)! !

Object subclass: #TimerStub
	instanceVariableNames: 'expired'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'EjerciciosPoo-TusLibros'!

!TimerStub methodsFor: 'as yet unclassified' stamp: 'RavasiAronson 6/26/2012 01:17'!
currentTime
	^TimeStamp current! !

!TimerStub methodsFor: 'as yet unclassified' stamp: 'RavasiAronson 6/26/2012 01:22'!
expire
	expired := true.! !

!TimerStub methodsFor: 'as yet unclassified' stamp: 'RavasiAronson 6/26/2012 01:17'!
initialize
	expired := false.! !

!TimerStub methodsFor: 'as yet unclassified' stamp: 'RavasiAronson 6/26/2012 01:26'!
thirtyMinsAgo
	^ TimeStamp current
		+
			((Duration minutes: 30) * (expired
				ifTrue: 1
				ifFalse: -1))! !
